package org.netkernel.ext.system.accessor;

import org.netkernel.container.IKernel;
import org.netkernel.container.ILogger;
import org.netkernel.container.impl.Kernel;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.scheduler.Scheduler;

public class KillAccessor extends StandardAccessorImpl
{
	public KillAccessor()
	{	declareThreadSafe();
	}
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		String request=aContext.getThisRequest().getArgumentValue("root");
		long requestId=Long.parseLong(request);
		String reason=aContext.source("arg:reason", String.class);
		
		IKernel k=aContext.getKernelContext().getKernel();
		Kernel kImpl=(Kernel)k;
		Scheduler scheduler = kImpl.getScheduler();
		
		boolean killed=scheduler.kill(requestId, reason);
		if (!killed)
		{	k.getLogger().log(ILogger.SEVERE, this, "MSG_NO_KILL",request);
		}
		INKFResponse resp=aContext.createResponseFrom(killed);
		resp.setExpiry(INKFResponse.EXPIRY_ALWAYS);
	}
}
